package com.jzlife.report.anno;


import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

@Target(value = {ElementType.METHOD,ElementType.TYPE})
@Retention(RetentionPolicy.RUNTIME)
public @interface LogRecordFiled {

    /**
     * 是否启用记录日志
     *
     * @return
     */
    boolean isUse() default true;

    /**
     * 系统后台名称 ，默认 报表系统
     *
     * @return
     */
    String sysName() default "报表系统";

    /**
     * 具体那个报表
     *
     * @return
     */
    String funName();


    /**
     * 备注
     *
     * @return
     */
    String remark() default "记录导出日志";
}
