package com.jzlife.report.config.datasource;

import com.alibaba.druid.spring.boot.autoconfigure.DruidDataSourceBuilder;
import lombok.Data;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.context.annotation.Primary;

import javax.sql.DataSource;

/**
 * @author fuxubing
 */
@Configuration
@Data
public class DataSourceConfig {


    @Bean
    @ConfigurationProperties(prefix = "spring.datasource.manager")
    public DataSource getManagerDataSource() {
        return DruidDataSourceBuilder.create().build();
    }

    @Bean
    @ConfigurationProperties(prefix = "spring.datasource.nurse")
    public DataSource getNurseDataSource() {
        return DruidDataSourceBuilder.create().build();
    }

    @Bean
    @Primary
    @ConfigurationProperties(prefix = "spring.datasource.hmorder")
    public DataSource getHmorderDataSource() {
        return DruidDataSourceBuilder.create().build();
    }

}

