package com.jzlife.report.controller;

import com.alibaba.fastjson.JSONObject;
import com.jzlife.report.entity.reports.DimLocationBaseInfo;
import com.jzlife.report.service.newreport.BaseService;
import com.jzlife.report.service.nurse.CityStationService;
import com.jzlife.report.util.ResponseUtil;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.util.List;
import java.util.Map;

@RestController
@RequestMapping("citystation")
public class CityStationController {

    @Autowired
    CityStationService roleDataService;

    @Autowired
    @Qualifier(value = "baseServiceImpl")
    BaseService baseService;

    @ApiOperation(value = "查询用户拥有的权限数据", notes = "查询用户拥有的权限数据")
    @RequestMapping(value = "/getUserAuthBuzData", method = RequestMethod.GET)
    public Object getUserAuthBuzData(Long userId) {
        if (userId == null) {
            return ResponseUtil.fail();
        }
        // 返回用户角色下所有的数据，去重后的
        return ResponseUtil.ok(roleDataService.getReportUserDataAuth(userId));
    }


    @GetMapping("getCityStation")
    @ApiOperation(value = "查询招商看板的城市-服务站", notes = "查询招商看板的城市-服务站")
    public Object getCityStation(Long userId) {
        if (userId == null) {
            return ResponseUtil.fail();
        }
        Map dataMap = baseService.getOwnCityAndStation(userId);
        return ResponseUtil.ok(dataMap);
    }

    @GetMapping("getHmCityStation")
    @ApiOperation(value = "查询服务力&服务质量看板的城市-服务站-门店", notes = "查询服务力&服务质量看板的城市-服务站-门店")
    public Object getHmCityStation(Long userId) {
        if (userId == null) {
            return ResponseUtil.fail();
        }
        Map dataMap = baseService.getHmCityAndStation(userId);
        return ResponseUtil.ok(dataMap);
    }

    @GetMapping("getLocationAllInOne")
    @ApiOperation(value = "查询地址信息对应表", notes = "查询地址信息对应表")
    public Object getLocationAllInOne(HttpServletRequest request) {
        String allowCity = request.getHeader("allowCity");
        JSONObject locations = baseService.getLocationAllInOne(allowCity);
        return ResponseUtil.ok(locations);
    }
}
