package com.jzlife.report.controller;

import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.jzlife.report.anno.LogRecordFiled;
import com.jzlife.report.dao.douyin.DouyinFianceMapper;
import com.jzlife.report.dto.douyin.DouyinFianceVo;
import com.jzlife.report.util.ExcelUtils;
import com.jzlife.report.util.ResponseUtil;
import io.swagger.annotations.ApiOperation;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletResponse;
import java.util.List;

/**
 * 抖音财务报表
 */
@RestController
@RequestMapping("douyinFiance")
public class DouyinFianceController {

    @Resource
    private DouyinFianceMapper fianceMapper;

    @ApiOperation(value = "抖音小程序财务报表", httpMethod = "GET", notes = "财务对账单")
    @GetMapping("fiance")
    @LogRecordFiled(funName = "财务对账单")
    public Object getFiance(
            @RequestParam(value = "startDate", required = false) String startDate,
            @RequestParam(value = "endDate", required = false) String endDate,
            @RequestParam(value = "salesStartDate", required = false) String salesStartDate,
            @RequestParam(value = "salesEndDate", required = false) String salesEndDate,
            Integer isSettle,
            String orderSn,
            Boolean isExport,
            Integer page, Integer limit, HttpServletResponse response) throws Exception {
        if (isExport == null || isExport == false) {
            PageHelper.startPage(page, limit);
            List<DouyinFianceVo> list = fianceMapper.getList(startDate, endDate, isSettle, orderSn, salesStartDate, salesEndDate);
            return ResponseUtil.ok(new PageInfo<>(list));
        } else {
            List<DouyinFianceVo> list = fianceMapper.getList(startDate, endDate, isSettle, orderSn, salesStartDate, salesEndDate);
            ExcelUtils.exportExcel(list, null, "Sheet1", DouyinFianceVo.class, "douyinpage.xls", response);
            return null;
        }
    }

}
