package com.jzlife.report.dao.hmorder;

import org.apache.ibatis.annotations.Param;

import com.jzlife.report.dto.export.BdInvertDetailExportDto;

import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

public interface SalesOrderMapper {

    // 某年销售的
    BigDecimal countSalesYear(@Param("city") String city,@Param("year")String year);

    // 某月销售的
//    Map<String, BigDecimal> countSalesYm(@Param("city") String city,@Param("yearMonth")String yearMonth);
    Map<String, BigDecimal> countSalesYm(@Param("city") String city,@Param("startDate")String startDate,
    		@Param("endDate")String endDate);

    // 某月服务的
//    BigDecimal countServiceYm(@Param("city") String city,@Param("yearMonth")String yearMonth);
    BigDecimal countServiceYm(@Param("city") String city,@Param("startDate")String startDate,
    		@Param("endDate")String endDate);

    // 某月退款
    BigDecimal countRefundYm(String yearMonth);

    // 某月的复购
//    BigDecimal countfugou(@Param("city") String city,@Param("yearMonth")String yearMonth);
    BigDecimal countfugou(@Param("city") String city,@Param("startDate")String startDate,@Param("endDate")String endDateh);

    // 销售目标值
    BigDecimal salesGmvTarget(@Param("city") String city,@Param("businessType") String businessType,@Param("category") String category, @Param("startMonth") String startMonth,
                              @Param("endMonth") String endMonth);

    //保洁，品类新客率
    Map<String, BigDecimal> newCustomerRate(@Param("city") String city,@Param("yearMonth")String yearMonth);

    // 线索转换率
    BigDecimal clueZhl(@Param("city") String city,@Param("yearMonth")String yearMonth);

    // 月销售gmv
    List<Map<String, Object>> salesGmvqushiMonth(@Param("channel") String channel, @Param("cityName") String cityName, @Param("buType") String buType,
    		@Param("businessLine") String businessLine, @Param("month") List<String> month);
    
    // 月销售gmv 细分保洁商品
    List<Map<String, Object>> salesGmvqushiMonthBj(@Param("channel") String channel, @Param("cityName") String cityName, @Param("levelOne") String levelOne,
    		@Param("goodsIds") String goodsIds, @Param("month") List<String> month);

    // 销售gmv --日
    List<Map<String, Object>> salesGmvqushiDay(@Param("channel") String channel,  @Param("cityName") String cityName, @Param("buType") String buType,
    		@Param("businessLine") String businessLine, @Param("date") List<String> date);

    // 月服务单量
    List<Map<String, Object>> serviceGmvdanliangMonth( @Param("cityName") String cityName, @Param("buType") String buType,
                                                    @Param("month") List<String> month);

    // 日服务单量
    List<Map<String, Object>> serviceGmvdanliangDay( @Param("cityName") String cityName, @Param("buType") String buType,
                                                  @Param("date") List<String> date);

    List<String> getChannel();

    List<String> getNurseSource();

    /**
     * BD转化率
     *
     * @param startTime
     * @param endTime
     * @param city
     * @return
     */
    List<Map<String, Object>> bdInvertDetail(@Param("startTime") String startTime, @Param("endTime") String endTime, @Param("city") String city);

    /**
     * 沉寂客户数
     * @param data 30天之前
     * @return
     */
    Integer countCustomerQuiet(@Param("city") String city,@Param("data") String data);

    //开单金额
    BigDecimal kaidan(@Param("city") String city,@Param("yearMonth")String yearMonth);
    
    List<Map<String, Object>> getBjGoodsArrt();
}
