package com.jzlife.report.dao.manager;

import com.github.pagehelper.Page;
import com.jzlife.report.dto.*;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

public interface CallTaskMapper {

    /**
     * 获取所有坐席
     * @return
     */
    List<CrmSysUser> selectAllUser();

    List<OBCallTask> selectCallTask(@Param("startTime") String startTime, @Param("endTime") String endTime, @Param("campaignId") Integer campaignId);

    List<IBCallDTO> selectIB(@Param("startTime") String startTime, @Param("endTime") String endTime);

    /**
     * 工单类型咨询明细报表=电访任务工单明细报表
     *
     * @param campaignId
     * @param startTime
     * @param endTime
     * @return
     */
    List<ConsultTypeDetailReport> ticketConsultTypeDetailReport(@Param("campaignId") Integer campaignId,
                                                                @Param("startTime") String startTime, @Param("endTime") String endTime);

    /**
     * 电访拨打情况报表
     *
     * @param startTime
     * @param endTime
     * @param campaigns
     * @return
     */
    List<ReportCallResultVo> selectCallResult(@Param("startTime") String startTime, @Param("endTime") String endTime, @Param("campaigns") String campaigns);


    /**
     * 电访拨打情况报表--任务看板使用
     *
     * @param startTime
     * @param endTime
     * @param city
     * @return
     */
    List<OBCallTask> selectCallTaskBoard(@Param("startTime") String startTime, @Param("endTime") String endTime, @Param("city") String city);


    /**
     * 电访任务 看板数据 到负责人
     *
     * @param startTime
     * @param endTime
     * @param campaignId
     * @return
     */
    List<OBCallTaskDetail> selectCallTaskDetailBoard(@Param("startTime") String startTime, @Param("endTime") String endTime, @Param("campaignId") Integer campaignId);


    Page<Map<String, Object>> selectQywxCall(@Param("startTime") String startTime, @Param("endTime") String endTime, @Param("city") String city);

    /**
     * 外呼任务明细报表
     * @param startTime
     * @param endTime
     * @param users
     * @return
     */
    List<OBCallTaskDetailVo> selectOBCallDetailList(@Param("startTime") String startTime, @Param("endTime") String endTime,@Param("users") List<Integer> users);
}
