package com.jzlife.report.dto;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import java.util.Date;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * 各城市14天库存率
 */
@ApiModel(value = "各城市14天库存率")
@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
public class Report14daysCityStackRadio {
    @ApiModelProperty(value = "")
    private Integer id;

    /**
     * 时间，格式20211221
     */
    @ApiModelProperty(value = "时间，格式20211221")
    private String date;

    /**
     * 城市
     */
    @ApiModelProperty(value = "城市")
    private String city;

    /**
     * 供应商
     */
    @ApiModelProperty(value = "供应商")
    private String supplier;

    /**
     * 服务站类型  保洁站、品类站
     */
    @ApiModelProperty(value = "服务站类型  保洁站、品类站")
    private String stationType;

    /**
     * 服务站名称
     */
    @ApiModelProperty(value = "服务站名称")
    private String stationName;

    /**
     * 当日服务者数量
     */
    @ApiModelProperty(value = "当日服务者数量")
    private Integer currentDayServerCount;

    /**
     * 当日空闲服务者数量
     */
    @ApiModelProperty(value = "当日空闲服务者数量")
    private Integer currentDayLeisureServerCount;

    /**
     * 当日库存资源数
     */
    @ApiModelProperty(value = "当日库存资源数")
    private Integer currentDaySourceCount;

    /**
     * 当日已被占用资源数
     */
    @ApiModelProperty(value = "当日已被占用资源数")
    private Integer currentDayUsedSourceCount;

    /**
     * 当日可用库存数
     */
    @ApiModelProperty(value = "当日可用库存数")
    private Integer currentDayLeisureSourceCount;

    /**
     * 当日库存率
     */
    @ApiModelProperty(value = "当日库存率")
    private String statckRadio;

    /**
     * 导入时间
     */
    @ApiModelProperty(value = "导入时间")
    private Date importDate;


    @ApiModelProperty(value = "批次ID")
    private Integer batchId;
}
