package com.jzlife.report.dto.excelimport;

import com.alibaba.excel.annotation.ExcelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;


/**
 * 盒马 生活服务数据导入
 */
@Data
public class LifeServiceImportData {

    /**
     * 库存业务时间
     */
    @ExcelProperty(value = "库存业务日期", index = 0)
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    private String stockDate;

    /**
     * 供应商
     */
    @ExcelProperty(value = "供应商", index = 1)
    private String supplier;

    /**
     * 门店名称
     */
    @ExcelProperty(value = "门店", index = 3)
    private String shopName;

    /**
     * skucode
     */
    @ExcelProperty(value = "skucode", index = 4)
    private Long sku;

    /**
     * 商品id
     */
    @ExcelProperty(value = "商品id", index = 5)
    private String productId;

    /**
     * 商品名称
     */
    @ExcelProperty(value = "商品名称", index = 6)
    private String productName;

    /**
     * 时间段
     */
    @ExcelProperty(value = "时段", index = 7)
    private String timeStamp;

    /**
     * 总份数
     */
    @ExcelProperty(value = "总份数", index = 8)
    private Integer totalCount;

    /**
     * 剩余可用份数
     */
    @ExcelProperty(value = "剩余可约份数", index = 9)
    private Integer freeCount;

}
