package com.jzlife.report.entity.reports;

import cn.afterturn.easypoi.excel.annotation.Excel;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;

import java.math.BigDecimal;
import java.time.LocalDateTime;
import java.util.Date;

@Data
public class DyLaikeShopEvaltion {
    private Integer id;

    /**
     * 批次号
     */
    @Excel(name = "批次号")
    private Integer batchId;

    /**
     * 门店poi_id
     */
    @Excel(name = "门店poi_id")
    private String shopPoiId;

    /**
     * 加盟商id
     */
    @Excel(name = "加盟商id")
    private Integer fraId;

    /**
     * 加盟商名称
     */
    @Excel(name = "加盟商名称")
    private String fraName;

    /**
     * 门店名
     */
    @Excel(name = "门店名")
    private String shopName;

    /**
     * 得分
     */
    @Excel(name = "得分")
    private BigDecimal score;

    /**
     * 评价数
     */
    @Excel(name = "评价数")
    private Integer evaCount;

    /**
     * 上月评价数
     */
    @Excel(name = "上月评价数")
    private Integer evaLastMonthCount;

    /**
     * 上月好评数
     */
    @Excel(name = "上月好评数")
    private Integer evaLastGoods;

    /**
     * 上月差评数
     */
    @Excel(name = "上月差评数")
    private Integer evaLastBad;

    /**
     * 抖音侧更新评价时间
     */
    @Excel(name = "抖音侧更新评价时间", width = 20, format = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date evaUpdateTime;

    @Excel(name = "参考时间", width = 20, format = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date etlTime;
}
