package com.jzlife.report.entity.reports;

import cn.afterturn.easypoi.excel.annotation.Excel;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;


@Data
@ApiModel(value = "EvaluationInfoDetailByPersonResult", description = "可邀约好评-个人维度明细")
public class EvaluationInfoDetailByPersonResult implements Serializable {
    /**
     * 预约时间
     */
    @ApiModelProperty(value = "预约时间")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    @Excel(name = "预约时间", width = 20, exportFormat = "yyyy-MM-dd")
    private Date beginDate;

    /**
     * 开始时间
     */
    @ApiModelProperty(value = "开始时间")
    @Excel(name = "预约时间", width = 20)
    private String startTime;

    /**
     * 地址
     */
    @ApiModelProperty(value = "地址")
    @Excel(name = "地址", width = 40)
    private String addressName;

    /**
     * 商家ID
     */
    @ApiModelProperty(value = "商家ID")
    @Excel(name = "商家ID", width = 20)
    private String workerNo;

    /**
     * 姓名
     */
    @ApiModelProperty(value = "姓名")
    @Excel(name = "姓名", width = 20)
    private String workerName;

    /**
     * 服务时可评价，1可以0不可以
     */
    @ApiModelProperty(value = "服务时可评价，1可以0不可以")
    @Excel(name = "服务时可评价", width = 20)
    private String serviceTimeCanEvluate;

    /**
     * 当前可评价，1可以0不可以
     */
    @ApiModelProperty(value = "当前可评价，1可以0不可以")
    @Excel(name = "当前可评价", width = 20)
    private String nowCanEvluate;

    /**
     * 服务单号
     */
    @ApiModelProperty(value = "服务单号")
    @Excel(name = "服务单号", width = 40)
    private String payId;

    /**
     * 评价日期
     */
    @ApiModelProperty(value = "评价日期")
    @Excel(name = "评价日期", width = 20)
    private String evaluateTime;

    /**
     * 评价类型
     */
    @ApiModelProperty(value = "评价类型")
    @Excel(name = "评价类型", width = 20)
    private String goodBad;

    /**
     *
     */
    @ApiModelProperty(value = "服务订单号")
    @Excel(name = "服务订单号", width = 20)
    private String bookOrderNo;

    private static final long serialVersionUID = 1L;
}

