package com.jzlife.report.entity.reports;

import com.alibaba.excel.annotation.ExcelProperty;
import com.jzlife.report.anno.ExcelFiled;
import lombok.Data;

import java.util.Date;

/**
 * 14天服务站-服务者库存剩余率
 */
@Data
public class Report14daysCityStackRadioPerson {
    private Integer id;

    /**
     * 时间，格式20211221
     */
    @ExcelFiled(colName = "日期", dateFormat = "yyyyMMdd")
    @ExcelProperty(value = "日期", index = 0)
    private String date;

    /**
     * 城市
     */
    @ExcelFiled(colIndex = 1, colName = "城市")
    @ExcelProperty(value = "城市", index = 1)
    private String city;

    /**
     * 服务站类型  保洁站、品类站
     */
    @ExcelFiled(colIndex = 2, colName = "服务站类型")
    @ExcelProperty(value = "服务站类型", index = 2)
    private String stationType;

    /**
     * 服务站名称
     */
    @ExcelFiled(colIndex = 3, colName = "服务站")
    @ExcelProperty(value = "服务站", index = 3)
    private String stationName;

    /**
     * 服务者id
     */
    @ExcelFiled(colIndex = 4, colName = "服务者id")
    @ExcelProperty(value = "服务者id", index = 4)
    private String workerId;

    /**
     * 服务者姓名
     */
    @ExcelFiled(colIndex = 5, colName = "服务者姓名")
    @ExcelProperty(value = "服务者姓名", index = 5)
    private String workerName;

    /**
     * 当日库存资源数
     */
    @ExcelFiled(colIndex = 6, colName = "当日资源库存数")
    @ExcelProperty(value = "当日资源库存数", index = 6)
    private Integer currentDaySourceCount;

    /**
     * 当日已被占用资源数
     */
    @ExcelFiled(colIndex = 7, colName = "已被占用库存数")
    @ExcelProperty(value = "已被占用库存数", index = 7)
    private Integer currentDayUsedSourceCount;

    /**
     * 当日可用库存数
     */
    private Integer currentDayLeisureSourceCount;

    /**
     * 导入时间
     */
    private Date importDate;

    /**
     * 导入批次，首次为1，每次导入后加1.
     */
    private Integer batchId;
}
