package com.jzlife.report.entity.reports;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;

@ApiModel(value = "report_bj_evaluation_base_info")
@Data
public class ReportBjEvaluationBaseInfo {
    @ApiModelProperty(value = "")
    private Integer id;

    /**
     * 开始日期
     */
    @ApiModelProperty(value = "开始日期")
    @JsonFormat( pattern = "yyyy-MM-dd", timezone = "GMT+8")
    private Date beginDate;

    /**
     * 服务订单号
     */
    @ApiModelProperty(value = "服务订单号")
    private String bookOrderNo;

    /**
     * 站点名称
     */
    @ApiModelProperty(value = "站点名称")
    private String stationName;

    /**
     * 开始时间
     */
    @ApiModelProperty(value = "开始时间")
    private String startTime;

    /**
     * 地址名称
     */
    @ApiModelProperty(value = "地址名称")
    private String addressName;

    /**
     * 工人编号
     */
    @ApiModelProperty(value = "工人编号")
    private String workerNo;

    /**
     * 工人姓名
     */
    @ApiModelProperty(value = "工人姓名")
    private String workerName;

    /**
     * 付款id
     */
    @ApiModelProperty(value = "付款id")
    private String payId;

    /**
     * 付款时间
     */
    @ApiModelProperty(value = "付款时间")
    private String payTime;

    /**
     * 评价时间
     */
    @ApiModelProperty(value = "评价时间")
    private String evaluateTime;

    /**
     * 好评差评
     */
    @ApiModelProperty(value = "好评差评")
    private String goodBad;

    /**
     * 评价内容
     */
    @ApiModelProperty(value = "评价内容")
    private String comment;

    /**
     * 服务时间是否可以评价
     */
    @ApiModelProperty(value = "服务时间是否可以评价")
    private String serviceTimeCanEvluate;

    /**
     * 当前是否可以评价
     */
    @ApiModelProperty(value = "当前是否可以评价")
    private String nowCanEvluate;

    @ApiModelProperty(value = "")
    private Date createTime;
}
