package com.jzlife.report.excelExport;

import cn.afterturn.easypoi.excel.annotation.Excel;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;

/**
 * 投诉治理
 */
@ApiModel(value = "投诉治理")
@Data
public class ReportComplaintmanagementDTO {


    /**
     * 投诉编号
     */
    @ApiModelProperty(value = "投诉编号")
    @Excel(name = "投诉编号", width = 15)
    private String ticketSn;


    @ApiModelProperty(value = "投诉时间")
    @Excel(name = "投诉时间", width = 15)
    private String createTime;

    @ApiModelProperty(value = "城市")
    @Excel(name = "城市", width = 15)
    private String city;

    @Excel(name = "客诉工单类型", width = 15)
    private String serviceType;

    @Excel(name = "客诉类型", width = 20)
    private String consult;

    @Excel(name = "客诉一级", width = 10)
    private String consultOne;

    @Excel(name = "客诉二级", width = 10)
    private String consultTwo;

    /**
     * 业务时间
     */
    @ApiModelProperty(value = "业务时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @Excel(name = "业务时间", width = 25, exportFormat = "yyyy-MM-dd HH:mm:ss")
    private Date businessTime;

    /**
     * 投诉内容
     */
    @ApiModelProperty(value = "投诉内容")
    @Excel(name = "投诉内容", width = 30)
    private String ticketDec;

    /**
     * 状态
     */
    @ApiModelProperty(value = "状态")
    @Excel(name = "状态", width = 15)
    private String status;

    /**
     * 子状态
     */
    @ApiModelProperty(value = "子状态")
    @Excel(name = "子状态", width = 25)
    private String subStatus;

    /**
     * 责任方
     */
    @ApiModelProperty(value = "责任方")
    @Excel(name = "责任方", width = 15)
    private String resParty;

    /**
     * 合作方
     */
    @ApiModelProperty(value = "合作方")
    @Excel(name = "合作方", width = 15)
    private String parterName;

    /**
     * 盒马工单号
     */
    @ApiModelProperty(value = "盒马工单号")
    @Excel(name = "盒马工单号", width = 20)
    private String bookSn;

    /**
     * 工号
     */
    @ApiModelProperty(value = "工号")
    @Excel(name = "工号", width = 20)
    private String workerNo;

    /**
     * 姓名
     */
    @ApiModelProperty(value = "姓名")
    @Excel(name = "姓名", width = 20)
    private String workerName;

    /**
     * 初步判定
     */
    @ApiModelProperty(value = "初步判定")
    @Excel(name = "初步判定", width = 15)
    private String firstDecide;

    /**
     * 罚款金额
     */
    @ApiModelProperty(value = "罚款金额")
    @Excel(name = "罚款金额", width = 15)
    private String firstFineAmount;

    /**
     * 是否走保险
     */
    @ApiModelProperty(value = "是否走保险")
    @Excel(name = "是否走保险", width = 15)
    private String isClaim;

    /**
     * 服务站
     */
    @ApiModelProperty(value = "服务站")
    @Excel(name = "服务站", width = 40)
    private String stationName;

    /**
     * 站长
     */
    @ApiModelProperty(value = "站长")
    @Excel(name = "站长", width = 15)
    private String stationManager;

    /**
     * 城市改善动作
     */
    @ApiModelProperty(value = "城市改善动作")
    @Excel(name = "城市改善动作", width = 15)
    private String stationImprove;

    /**
     * 城市改善动作
     */
    @ApiModelProperty(value = "城市改善动作描述")
    @Excel(name = "城市改善动作描述", width = 15)
    private String stationImproveDes;

    /**
     * 城市差评反馈
     */
    @ApiModelProperty(value = "城市差评反馈")
    @Excel(name = "城市差评反馈", width = 40)
    private String stationImproveFeedback;

    /**
     * 申诉时间
     */
    @ApiModelProperty(value = "申诉时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @Excel(name = "申诉时间", width = 25, exportFormat = "yyyy-MM-dd HH:mm:ss")
    private Date appealTime;

    /**
     * 申诉备注
     */
    @ApiModelProperty(value = "申诉备注")
    @Excel(name = "申诉备注", width = 40)
    private String appealMemo;

    /**
     * 申诉处理时间
     */
    @ApiModelProperty(value = "申诉处理时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @Excel(name = "申诉处理时间", width = 25, exportFormat = "yyyy-MM-dd HH:mm:ss")
    private Date secondTime;

    /**
     * 二次判定结果
     */
    @ApiModelProperty(value = "二次判定结果")
    @Excel(name = "二次判定结果", width = 40)
    private String secondDecide;

    /**
     * 二次判定处理人
     */
    @ApiModelProperty(value = "二次判定处理人")
    @Excel(name = "二次判定处理人", width = 20)
    private String userName1;

    /**
     * 城市承担金额
     */
    @ApiModelProperty(value = "城市承担金额")
    @Excel(name = "城市承担金额", width = 15)
    private String stationBearAmount;

    /**
     * 保洁师承担金额
     */
    @ApiModelProperty(value = "保洁师承担金额")
    @Excel(name = "保洁师承担金额", width = 20)
    private String secondFineAmount;

    /**
     * 更新时间
     */
    @ApiModelProperty(value = "更新时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @Excel(name = "更新时间", width = 25, exportFormat = "yyyy-MM-dd HH:mm:ss")
    private Date updateTime;

    /**
     * 最终处理人
     */
    @ApiModelProperty(value = "最终处理人")
    @Excel(name = "最终处理人", width = 15)
    private String userName;

    /**
     * 工单来源
     */
    @ApiModelProperty(value = "工单来源")
    @Excel(name = "工单来源", width = 15)
    private String ticketSource;

    @ApiModelProperty(value = "入职天数")
    @Excel(name = "入职天数", width = 15)
    private Integer entryDay;

    @ApiModelProperty(value = "赔偿现金")
    @Excel(name = "赔偿现金", width = 15)
    private Integer ticketFines;
}
