package com.jzlife.report.service;

import com.alibaba.excel.context.AnalysisContext;
import com.alibaba.excel.read.listener.ReadListener;
import com.jzlife.report.dao.reports.HmScheduleMapper;
import com.jzlife.report.dto.excelimport.HmScheduleExcel;
import com.jzlife.report.entity.reports.HmSchedule;
import com.jzlife.report.util.DateUtil;
import com.jzlife.report.util.SpringContextUtils;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.BeanUtils;

import java.util.Date;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

@Slf4j
public class HmScheduleListener implements ReadListener<HmScheduleExcel> {

    private String batchNo;

    private HmScheduleMapper hmScheduleMapper;

    private List<HmSchedule> list = new LinkedList<>();

    private int max_count = 1000;

    public HmScheduleListener(String times) {
        this.batchNo = times;
        hmScheduleMapper = SpringContextUtils.getBeanByClass(HmScheduleMapper.class);
    }

    @Override
    public void invoke(HmScheduleExcel h, AnalysisContext context) {
        HmSchedule s = new HmSchedule();
        BeanUtils.copyProperties(h, s);
        s.setCreateTime(new Date());
        s.setBatchNo(batchNo);

        if (h.getEntryTime() != null) {
            s.setEntryTime(DateUtil.stringToDate(h.getEntryTime()));
        }
        if (h.getCancelTime() != null) {
            s.setCancelTime(DateUtil.stringToDate(h.getCancelTime()));
        }
        if (h.getScheduleDate() != null) {
            s.setScheduleDate(DateUtil.stringToDate(h.getScheduleDate()));
        }
        if (h.getScheduleStart() != null) {
            s.setScheduleStart(DateUtil.stringToDate(h.getScheduleStart(), "hh:mm:ss"));
        }
        if (h.getScheduleEnd() != null) {
            s.setScheduleEnd(DateUtil.stringToDate(h.getScheduleEnd(), "hh:mm:ss"));
        }
        list.add(s);
        if (list.size() > max_count) {
            hmScheduleMapper.batchInsert(list);
            list.clear();
        }

    }

    @Override
    public void doAfterAllAnalysed(AnalysisContext context) {
        if (list.size() > 0) {
            hmScheduleMapper.batchInsert(list);
            list.clear();
        }
        hmScheduleMapper.filterdelete(batchNo);
    }
}
