package com.jzlife.report.service.douyin;

import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import com.alibaba.fastjson.JSONObject;
import com.jzlife.report.config.DouyinConfig;
import com.jzlife.report.dto.douyin.DouYinToken;
import com.jzlife.report.dto.douyin.DouyinResultVo;
import com.jzlife.report.util.HttpsUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.io.IOException;


@Service
public class DouyinTokenService {

    private static DouYinToken douyinToken;

    @Autowired
    private DouyinConfig config;

    public DouYinToken getToken() {
        try {
            if (douyinToken == null || DateTime.now().isAfter(douyinToken.getExpires_time())) {
                JSONObject json = new JSONObject();
                json.put("appid", config.getAppid());
                json.put("secret", config.getSecret());
                json.put("grant_type", "client_credential");
                String result = HttpsUtils.doPost(config.getUrl_token(), json.toJSONString());
                DouyinResultVo douyinResultVo = JSONObject.parseObject(result, DouyinResultVo.class);

                if (douyinResultVo.getErr_no().intValue()==0) {
                    douyinToken = douyinResultVo.getData();
                    douyinToken.setExpires_time(DateUtil.offsetSecond(DateTime.now(), douyinToken.getExpires_in().intValue() - 20));
                } else return null;
            }
            return douyinToken;
        } catch (
                IOException ex) {
            ex.printStackTrace();
        }
        return null;
    }
}
