package com.jzlife.report.service.hmorder.impl;

import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.alibaba.druid.support.json.JSONUtils;
import com.jzlife.report.dao.hmorder.DiRReportMapper;
import com.jzlife.report.dao.hmorder.DiRSchedulingMapper;
import com.jzlife.report.dao.hmorder.DiRTeamMapper;
import com.jzlife.report.dao.hmorder.HmBookTradeOrderMapper;
import com.jzlife.report.dao.hmorder.diRLeaveMapper;
import com.jzlife.report.dao.nurse.SysCityMapper;
import com.jzlife.report.entity.hmorder.DiRReport;
import com.jzlife.report.entity.hmorder.DiRScheduling;
import com.jzlife.report.entity.hmorder.DiRTeam;
import com.jzlife.report.entity.hmorder.HmBookTradeOrder;
import com.jzlife.report.entity.hmorder.diRLeave;
import com.jzlife.report.entity.nurse.SysCity;
import com.jzlife.report.service.hmorder.DiReportService;
import com.jzlife.report.util.JsonUtil;

import lombok.extern.slf4j.Slf4j;

@Service
@Slf4j
public class DiReportServiceImpl implements DiReportService {

	@Autowired
	HmBookTradeOrderMapper hmBookTradeOrderMapper;

	@Autowired
	DiRTeamMapper diRTeamMapper;

	@Autowired
	SysCityMapper sysCityMapper;

	@Autowired
	DiRSchedulingMapper diRSchedulingMapper;

	@Autowired
	diRLeaveMapper diRLeaveMapper;

	@Autowired
	DiRReportMapper diRReportMapper;



	public static String LEVEL_PINGLEI = "品类";
	public static String LEVEL_RIBAO = "日保";
	public static DateFormat df = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");

	public static DateFormat dfd = new SimpleDateFormat("yyyy-MM-dd");

	/**
	 * select ho.id,ho.begin_time,ho.start_time, ho.end_time ,ho.item_name From
	 * hm_book_trade_order ho left join di_merchandise_display dimd on
	 * ho.item_name=dimd.goods_name where date(ho.start_time) ='2020-11-21' and (
	 * ho.`status`=9 or ho.`status`=2) and (dimd.level_one='日保' or
	 * dimd.level_one='品类');
	 * 
	 * update di_r_scheduling set   tels=replace (`tel`,'TEL','');
	 */

	@Override
	public void generationReport(String dataTime) {
		Long bn=System.currentTimeMillis();
		Date dt =null;
		try {
			dt = dfd.parse(dataTime);
		} catch (Exception e) {
			e.printStackTrace();
		}

		//过滤数据，计算出工时
		filterSecheduling(dataTime);


		//插入 报表数据 *9小时
		List<SysCity> cityList = sysCityMapper.selectAll();
		for(SysCity s:cityList) {
			// 全部的 不分品类日保
			List<HmBookTradeOrder> dataAllOrder = hmBookTradeOrderMapper.selectByStartTimeType(dataTime, null,s.getCityName());
			List<DiRScheduling>  workList = diRSchedulingMapper.selectDataByTime(dataTime, s.getCityName()); 
			Double WorkTimeall = getJsWorkerTime(workList);//diRSchedulingMapper.selectSumWorkTime(dataTime, s.getCityName());
			Integer OrderTimeAll= getWorketOrderTime(dataAllOrder);//服务单工时
			//报表类型：1总体，2品类，3日保
			insertReport(1,bn, dt, s, dataAllOrder, workList, WorkTimeall, OrderTimeAll);

			// 品类
			List<HmBookTradeOrder> dataPingleiOrder = hmBookTradeOrderMapper.selectByStartTimeType(dataTime, LEVEL_PINGLEI,s.getCityName());
			List<DiRScheduling> plWorkList = getPlJsData(workList);
			Double plJsWorkerTime = getJsWorkerTime(plWorkList);
			Integer workerOrderTimePinglei= getWorketOrderTime(dataPingleiOrder);
			insertReport(2,bn, dt, s, dataPingleiOrder, plWorkList, plJsWorkerTime, workerOrderTimePinglei);



			List<HmBookTradeOrder> dataRibaoOrder = hmBookTradeOrderMapper.selectByStartTimeType(dataTime, LEVEL_RIBAO,s.getCityName());
			List<DiRScheduling> rbWorkList = getNotPlJsData(workList);
			Double rbJsWorkerTime = getJsWorkerTime(rbWorkList);
			Integer workerOrderTimeRibao= getWorketOrderTime(dataRibaoOrder);
			insertReport(3,bn, dt, s, dataRibaoOrder, rbWorkList, rbJsWorkerTime, workerOrderTimeRibao);
		}


	}

	public Double getJsWorkerTime(List<DiRScheduling> list) {
		Double sm=0.0;
		for(DiRScheduling d:list) {
			if(null!=d.getTeamWorkTime()) {
				sm=sm+d.getTeamWorkTime();
			}
		}

		return sm;
	}

	/**
	 * 品类技师数据
	 * @return
	 */
	public List<DiRScheduling> getPlJsData(List<DiRScheduling> list){
		List<DiRScheduling> tempList=new ArrayList<DiRScheduling>();
		for(DiRScheduling d:list) {
			if(d.getStationName().contains("品类")) {
				tempList.add(d);
			}
		}
		return tempList;
	}

	/**
	 * 非品类技师数据
	 * @param list
	 * @return
	 */
	public List<DiRScheduling> getNotPlJsData(List<DiRScheduling> list){
		List<DiRScheduling> tempList=new ArrayList<DiRScheduling>();
		for(DiRScheduling d:list) {
			if(!d.getStationName().contains("品类")) {
				tempList.add(d);
			}
		}
		return tempList;
	}

	private void insertReport(int type,Long bn, Date dt, SysCity s, List<HmBookTradeOrder> dataAllOrder,
			List<DiRScheduling> workList, Double WorkTimeall, Integer OrderTimeAll) {
		DiRReport record=new DiRReport();
		record.setBeatchNo(bn.toString());
		record.setCityId(s.getId());
		record.setCityName(s.getCityName());
		record.setDays(dt);
		record.setReportType(type); //报表类型：1总体，2品类，3日保

		record.setEntryWorkSum(workList.size());//保洁师数量
		record.setWorkOrderSum(dataAllOrder.size());//工单总数量
		//record.setOrderTimeSum(Double.valueOf(OrderTimeAll.toString()));//工单总工时
		
		if(OrderTimeAll!=null&&OrderTimeAll!=0.0) {
			record.setOrderTimeSum((double)(OrderTimeAll*1.0));//工单总工时
		}else {
			record.setOrderTimeSum(0.0);
		}
		
		record.setWorkTimeSum(WorkTimeall);//技师总工时
		if(null!=record.getOrderTimeSum() && record.getOrderTimeSum()!=0.0
				&& null!=record.getWorkTimeSum() && record.getWorkTimeSum() !=0.0) {
			record.setPersonAvgTime(record.getOrderTimeSum()/record.getWorkTimeSum());
		}else {
			record.setPersonAvgTime(0.0);
		}

		diRReportMapper.insertSelective(record);
	}

	/**
	 * 过滤保洁师离职 请假。。。。
	 * @param dataTime
	 */
	private void filterSecheduling(String dataTime) {

		//初始把report当天的设置is_valid=1
		diRReportMapper.updateValid(dataTime);
		
		//1. 修改di_r_scheduling di_r_leave修改排班表和请假表的手机号 ，把TEL去掉
		diRLeaveMapper.updateTels();
		//把TEL去掉,同时初始化is_bring为1 可用
		diRSchedulingMapper.updateTelsAndDefaultBring();

		//2.服务站未可用过滤，离职后排班不纳入统计 标记1有效，0无效
		diRSchedulingMapper.updateStationFail(dataTime);

		//3.把班组名称休息过滤，标记1有效，0无效
		diRSchedulingMapper.updateTeamNameRest(dataTime);

		//4把排班表里的人到保洁去匹配按照手机号匹配，标记有效的保洁师，1有效，0无效
		List<String> phoneList = diRSchedulingMapper.findExitTel(dataTime);
		if(null!=phoneList && phoneList.size()>0) {
			String pl=StringUtils.join(phoneList.toArray(), ',');
			diRSchedulingMapper.updateNotInPhone(dataTime, pl);
		}

		//计算工时
		List<DiRScheduling>  workTimeList = calculationWorkTime(dataTime);
		//更新工时
		for(DiRScheduling t:workTimeList) {
			DiRScheduling tempw=new DiRScheduling();
			tempw.setId(t.getId());
			tempw.setTeamWorkTime(t.getTeamWorkTime());
			diRSchedulingMapper.updateByPrimaryKeySelective(tempw);
		}
	}

	/**
	 * 计算保洁师工时，过滤请假
	 * @param dataTime
	 * @return
	 */
	private List<DiRScheduling>  calculationWorkTime(String dataTime) {
		String currentDay=dfd.format(new Date());

		//查询当日数据，用DiRTeam匹配工时 工时乘9，再查询请假数据，去除请假工时，再更新
		//请假计算select *From di_r_leave where  date(leave_starttime)<='2020-12-20' and   date(leave_endtime)>='2020-12-20'
		//用时间的 时分 除以24， 再乘以9

		//  工时字典表查询
		List<DiRTeam> teamList = diRTeamMapper.selectAll();
		//请假数据
		List<diRLeave> dirLeaveList = diRLeaveMapper.selectByTime(dataTime);

		List<DiRScheduling> schedulingList = diRSchedulingMapper.selectDataByTime(dataTime, null);
		for(DiRScheduling d:schedulingList) {
			for(DiRTeam t:teamList) {
				if(d.getTeamStartTime().equals(t.getTeamStartTime()) 
						&& d.getTeamEndTime().equals(t.getTeamEndTime())) {
					d.setTeamWorkTime(t.getAttendanceCount()*9.0);
					break;
				}
			}

			for(diRLeave r:dirLeaveList) {
				if(r.getJsId().equals(d.getJsId())) {
					//请假开始日期和结束日期都是同一天
					if(currentDay.equals(dfd.format(r.getLeaveStarttime()))
							&&currentDay.equals(dfd.format(r.getLeaveEndtime()))) {
						String tempKs=df.format(r.getLeaveStarttime()).substring(11, 16).replace(":", ".");
						String tempJs=df.format(r.getLeaveEndtime()).substring(11, 16).replace(":", ".");

						double timeKs=(Double.valueOf(tempKs)/24.0);
						double timeJs=(Double.valueOf(tempJs)/24.0);

						double qjgs=(timeJs-timeKs)*9.0;
						double gs=d.getTeamWorkTime()-qjgs;
						d.setTeamWorkTime(gs);
						if(gs<0.0) {
							d.setTeamWorkTime(0.0);
						} 

					}else {
						//不是的直接设置工时为0
						d.setTeamWorkTime(0.0);
					}

					break;
				}
			}

		}
		return schedulingList;
	}



	public Integer getWorketOrderTime(List<HmBookTradeOrder> list) {
		int ct=0;

		for (HmBookTradeOrder t : list) {
			long diff=0L;
			try {
				// 这样得到的差值是毫秒级别
				diff = df.parse(t.getEndTime()).getTime()-df.parse(t.getStartTime()).getTime();
			} catch (ParseException e) {
				log.info("计算工单时长异常::"+JsonUtil.getJson(diff));
			}

			long days = diff / (1000 * 60 * 60 * 24);
			long hours = (diff - days * (1000 * 60 * 60 * 24)) / (1000 * 60 * 60);

			ct=ct+(int)hours;
		}

		return ct;
	}

	public static void main(String[] args) {
		System.out.println(Double.valueOf(df.format(new Date()).substring(11, 16).replace(":", ".")));
		//		DateFormat df = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
		//		try {
		//			Date d1 = df.parse("2018-03-26 11:30:00");
		//			Date d2 = df.parse("2018-03-26 15:30:00");
		//			long diff = d1.getTime() - d2.getTime();// 这样得到的差值是毫秒级别
		//			long days = diff / (1000 * 60 * 60 * 24);
		//			long hours = (diff - days * (1000 * 60 * 60 * 24)) / (1000 * 60 * 60);
		//			long minutes = (diff - days * (1000 * 60 * 60 * 24) - hours * (1000 * 60 * 60)) / (1000 * 60);
		//			System.out.println("" + days + "天" + hours + "小时" + minutes + "分");
		//		} catch (Exception e) {
		//		}
	}

}
