package com.jzlife.report.service.hmorder.impl;

import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.jzlife.report.dao.hmorder.SalesOrderExportMapper;
import com.jzlife.report.dto.BuzLineKewordDto;
import com.jzlife.report.dto.EchartsLine;
import com.jzlife.report.dto.HmSalesDto;
import com.jzlife.report.dto.SaleAppDto;
import com.jzlife.report.dto.export.ChannelSalesDto;
import com.jzlife.report.dto.export.CityProgressExportDto;
import com.jzlife.report.dto.export.CluePayOrderExportDto;
import com.jzlife.report.dto.export.MallDIffOrderExportDto;
import com.jzlife.report.dto.export.MonthSalesPlanExportDto;
import com.jzlife.report.dto.export.SalesReportExport;
import com.jzlife.report.dto.export.SelectClueDtoExport;
import com.jzlife.report.dto.export.ServantSignOrderExport;
import com.jzlife.report.dto.export.ServiceGMVCountExportDto;
import com.jzlife.report.dto.export.ServiceGmvExport;
import com.jzlife.report.service.hmorder.SalesOrderExportService;
import com.jzlife.report.util.AccountDate;
import com.jzlife.report.util.ExcelUtils;
import com.jzlife.report.util.ResponseUtil;
import com.jzlife.report.util.page.BeanUtil;
import com.jzlife.report.util.page.PagedResult;
import com.jzlife.report.vo.DayReportBaseVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Service
public class SalesOrderExportServiceImpl implements SalesOrderExportService {

	@Autowired
	SalesOrderExportMapper exportMapper;

	public Object selectLittleAppOrder(Integer pageNo, Integer pageSize, String startDate, String endDate,
									   String channel, String city, String levelOne, boolean isExport) {

		if (isExport == false) {
			PageHelper.startPage(pageNo, pageSize);
			List<SaleAppDto> data = exportMapper.selectLittleAppOrder(startDate, endDate, channel, city, levelOne);

			PagedResult<SaleAppDto> pagedResult = BeanUtil.toPagedResult(data);
			return ResponseUtil.ok(pagedResult);
		} else {

			return exportMapper.selectLittleAppOrder(startDate, endDate, channel, city, levelOne);
		}
	}

	@Override
	public Object selectChannelSales(Integer pageNo, Integer pageSize, String startDate, String endDate, String channel,
									 String city, String levelOne, Boolean isExport) {
		if (isExport) {
			return exportMapper.selectChannelSales(startDate, endDate, channel, city, levelOne);
		}
		PageHelper.startPage(pageNo, pageSize);
		List<ChannelSalesDto> data = exportMapper.selectChannelSales(startDate, endDate, channel, city, levelOne);
		PagedResult<ChannelSalesDto> pagedResult = BeanUtil.toPagedResult(data);
		return ResponseUtil.ok(pagedResult);

	}

	@Override
	public Object salesSummary(Integer pageNo, Integer pageSize, String startDate, String endDate, String channel,
							   String city, String levelOne) {
		PageHelper.startPage(pageNo, pageSize);
		List<SalesReportExport> data = exportMapper.salesSummary(startDate, endDate, channel, city, levelOne);

		PagedResult<SalesReportExport> pagedResult = BeanUtil.toPagedResult(data);
		return ResponseUtil.ok(pagedResult);
	}

	@Override
	public Object serviceGMVCount(Integer pageNo, Integer pageSize, String startDate, String endDate, String city,
								  String levelOne, Boolean isExport, String status, String channel) {

		if (isExport) {
			return exportMapper.serviceGMVCount(startDate, endDate, city, levelOne, status, channel);
		}

		PageHelper.startPage(pageNo, pageSize);
		List<ServiceGMVCountExportDto> data = exportMapper.serviceGMVCount(startDate, endDate, city, levelOne, status, channel);

		PagedResult<ServiceGMVCountExportDto> pagedResult = BeanUtil.toPagedResult(data);
		return ResponseUtil.ok(pagedResult);
	}

	@Override
	public Object monthSalesPlan(Integer pageNo, Integer pageSize, String startDate, String endDate, String city,
								 String levelOne, Boolean isExport) {
		if (isExport) {
			return exportMapper.monthSalesPlan(startDate, endDate, city, levelOne);
		}
		PageHelper.startPage(pageNo, pageSize);
		List<MonthSalesPlanExportDto> data = exportMapper.monthSalesPlan(startDate, endDate, city, levelOne);

		PagedResult<MonthSalesPlanExportDto> pagedResult = BeanUtil.toPagedResult(data);
		return ResponseUtil.ok(pagedResult);
	}

	@Override
	public Object notHMActualSales(String startDate, String endDate) {
		List<Map<String, Object>> list = exportMapper.notHMActualSales(startDate, endDate);

		List<Map<String, Object>> pieData = new ArrayList<Map<String, Object>>();

		// 非盒马渠道当月实销额扇形图
		for (Map<String, Object> e : list) {
			Map<String, Object> data = new HashMap<String, Object>();
			data.put("name", e.get("channel"));
			Object sxe = e.get("sxe");
			data.put("value", sxe == null ? 0 : sxe);
			pieData.add(data);
		}
		return ResponseUtil.ok(pieData);
	}

	@Override
	public Object selectClue(Integer pageNo, Integer pageSize, String startDate, String endDate, String resource,
							 String city, String serviceModel, Boolean isExport) {
		if (isExport) {
			return exportMapper.selectClue(startDate, endDate, resource, city, serviceModel);
		}

		PageHelper.startPage(pageNo, pageSize);
		List<SelectClueDtoExport> data = exportMapper.selectClue(startDate, endDate, resource, city, serviceModel);
		PagedResult<SelectClueDtoExport> pagedResult = BeanUtil.toPagedResult(data);

		return ResponseUtil.ok(pagedResult);
	}

	@Override
	public Object servantSignOrder(Integer pageNo, Integer pageSize, String startDate, String endDate, String city,
								   String remark, String serviceModel, Boolean isExport) {
		if (isExport) {
			return exportMapper.servantSignOrder(startDate, endDate, city, remark, serviceModel);
		}

		PageHelper.startPage(pageNo, pageSize);
		List<ServantSignOrderExport> data = exportMapper.servantSignOrder(startDate, endDate, city, remark, serviceModel);
		PagedResult<ServantSignOrderExport> pagedResult = BeanUtil.toPagedResult(data);

		return ResponseUtil.ok(pagedResult);
	}

	@Override
	public Object cluePayOrder(Integer pageNo, Integer pageSize, String startDate, String endDate, Boolean isExport) {
		if (isExport) {
			return exportMapper.cluePayOrder(startDate, endDate);
		}
		PageHelper.startPage(pageNo, pageSize);
		List<CluePayOrderExportDto> data = exportMapper.cluePayOrder(startDate, endDate);
		PagedResult<CluePayOrderExportDto> pagedResult = BeanUtil.toPagedResult(data);

		return ResponseUtil.ok(pagedResult);
	}


	@Override
	public Object danpingzoushi(String startDate, String endDate, String city, String levelOne, String keyWord,
								String channel) {
		Map<String, Object> data = new HashMap<String, Object>();

		List<EchartsLine> echList = new ArrayList<EchartsLine>();
		List<String> everyday = AccountDate.getEveryday(startDate, endDate);

		List<String> goodsLevelTwo = exportMapper.goodsLevelTwo(keyWord, levelOne, channel);
		List<Map<String, Object>> danpingzoushi = exportMapper.danpingzoushi(startDate, endDate, city, keyWord,
				levelOne, channel);

		for (String lv : goodsLevelTwo) {
			EchartsLine el = new EchartsLine("line");
			List<Object> tempList = new ArrayList<Object>();

			everyday.forEach(d -> {
				boolean boo = true;

				for (Map<String, Object> zs : danpingzoushi) {
					if (null != zs.get("actionDate") && null != zs.get("levelTwo")
							&& zs.get("actionDate").toString().equals(d) && zs.get("levelTwo").toString().equals(lv)) {
						tempList.add(zs.get("danliang"));
						boo = false;

					}
				}

				if (boo) {
					tempList.add(0);
				}

			});
			el.setName(lv);
			el.setData(tempList);
			if (!checkZero(tempList)) {
				echList.add(el);
			}
		}
		data.put("series", echList);
		data.put("days", everyday);

		return ResponseUtil.ok(data);
	}

	// 判断是否都是0
	public Boolean checkZero(List<Object> list) {
		for (Object s : list) {
			if (!s.toString().equals("0")) {
				return false;
			}
		}
		return true;
	}

	@Override
	public List<CityProgressExportDto> cityProgress(String date, Boolean isExport) {
//		String yearMonth=date.substring(0, 7);
		return exportMapper.cityProgress(date);

	}

	public List<BuzLineKewordDto> getBuzLine() {
		List<BuzLineKewordDto> list = new ArrayList<BuzLineKewordDto>();

		BuzLineKewordDto bk1 = new BuzLineKewordDto();
		bk1.setBuz("品类");
		BuzLineKewordDto bk2 = new BuzLineKewordDto();
		bk2.setBuz("保洁");
		list.add(bk1);
		list.add(bk2);

		list.forEach(e -> {
			List<String> goodsKeyWords = exportMapper.goodsKeyWords(e.getBuz());
			e.setKeywords(goodsKeyWords);
		});
		return list;
	}

	@Override
	public List<ServiceGmvExport> serviceGMVCountExport(String startDate, String endDate, String city,
														String levelOne, String status, String channel) {
		List<ServiceGmvExport> data = exportMapper.serviceGMVCountExport(startDate, endDate, city, levelOne, status, channel);

		return data;
	}

	@Override
	public List<SalesReportExport> salesSummaryExport(String startDate, String endDate, String channel, String city,
													  String levelOne) {
		return exportMapper.salesSummary(startDate, endDate, channel, city, levelOne);
	}

	public Object selectDiffOrder(Integer pageNo, Integer pageSize, String startDate, String endDate, Boolean isExport) {
		if (isExport) {
			return exportMapper.selectDiffOrder(startDate, endDate);
		}
		PageHelper.startPage(pageNo, pageSize);
		List<MallDIffOrderExportDto> data = exportMapper.selectDiffOrder(startDate, endDate);
		PagedResult<MallDIffOrderExportDto> pagedResult = BeanUtil.toPagedResult(data);

		return ResponseUtil.ok(pagedResult);
	}

	/**
	 * 盒马销售明细
	 *
	 * @param pageNo
	 * @param pageSize
	 * @param buyerPhone
	 * @param isExport
	 * @return
	 */
	@Override
	public List<HmSalesDto> selectHmSales(String startTime, String endTime, Integer pageNo, Integer pageSize, String buyerPhone, Boolean isExport) {
		return exportMapper.selectHmSales(startTime, endTime, isExport, buyerPhone);
	}

}
