package com.jzlife.report.service.newreport;

import com.github.pagehelper.PageInfo;
import com.jzlife.report.dto.Report30daysProductStocks;
import com.jzlife.report.dto.ReportOrderCoalescence;
import com.jzlife.report.entity.reports.ImportDataRecord;
import com.jzlife.report.entity.reports.TradeOrderAddress;
import com.jzlife.report.excelExport.*;
import com.jzlife.report.vo.*;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

public interface ServicePowerReportService  {


    PageInfo<Map<String, Object>> servicePowerTicketDetail(DayReportBaseVo vo);

    PageInfo<Map<String, Object>> servicePowerTicketInfo(DayReportBaseVo vo);

    PageInfo<Map<String, Object>> servicePowerServerInfo(DayReportBaseVo vo);

    PageInfo<Map<String, Object>> servicePowerStationPersonInfo(DayReportBaseVo vo);

    PageInfo<Map<String, Object>> servicePowerRentFee(ReportBaseVo vo);

    PageInfo<Map<String, Object>> servicePowerWornSubsidies(ReportBaseVo vo);

    PageInfo<Map<String, Object>> servicePowerTeacherReward(ReportBaseVo vo);

    PageInfo<Map<String, Object>> servicePowerOrderReward(ReportBaseVo vo);

    void import30DaysProductStock(List<Report30daysProductStocks> stations, String s);

    Object get30DaysProductStockResult(String serialNo);

    List<Map<String, Object>> service14DayStock(String city, String userId);

    Map<String, Object> serviceGoalData(String month, String userId, String city);

    // 服务站和商品库存
    Map<String, Object> stationAndShopStock(ReportStationAndShopVo vo);

    /**
     * 按 索引聚合热力图
     *
     * @param vo
     * @return
     */
    Map<String, Object> createOrderHeatMap(BaseRequestVo vo);

    void repairOrderLocation(@Param("bookDate") String bookDate);

    List<ReportOrderCoalescence> getOrderLocationByDay();

    /**
     * 保洁人均单量& 品类人均工时
     * @param vo
     * @return
     */
    Object cleanPerCapitalOrderQuality(ReportCleanPerCaptchaOrderQualityVo vo);

    List<ServicePowerTicketDetailDTO> servicePowerTicketDetailNoPage(DayReportBaseVo vo);

    List<ServicePowerTicketInfoDTO> servicePowerTicketInfoNoPage(DayReportBaseVo vo);

    List<ServicePowerServerInfoDTO> servicePowerServerInfoNoPage(DayReportBaseVo vo);

    List<ServicePowerStationPersonInfoDTO> servicePowerStationPersonInfoPage(DayReportBaseVo vo);

    List<ServicePowerRentFeeDTO> servicePowerRentFeeNoPage(DayReportBaseVo vo);

    List<ServicePowerWornSubsidiesDTO> servicePowerWornSubsidiesNoPage(DayReportBaseVo vo);

    List<ServicePowerTeacherRewardDTO> servicePowerTeacherRewardNoPage(DayReportBaseVo vo);

    List<ServicePowerOrderRewardDTO> servicePowerOrderRewardExportNoPage(DayReportBaseVo vo);

    /**
     *  	盒马商品30天库存，大文件导入，边读边写
     * @param filePath
     * @param dr
     */
    void import30DaysProductStockTask(String filePath, ImportDataRecord dr);

    //插入盒马商品30天库存数据
    void  import30DayProductStockData(List<List<String>> importList);

    int get14DayBatchId();

    Map<String, Object> importData(List<DaysStackRadioVo> stations);

    int get14DayPersonBatchId();

    void callProcedure();
}
