package com.jzlife.report.service.newreport.impl;

import com.alibaba.fastjson.JSONObject;
import com.jzlife.report.dao.manager.SysStationMappper;
import com.jzlife.report.dao.reports.DimLocationBaseInfoMapper;
import com.jzlife.report.entity.reports.DimLocationBaseInfo;
import com.jzlife.report.service.newreport.BaseService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;
import java.util.stream.Collectors;
import java.util.stream.Stream;


@Service
public class BaseServiceImpl implements BaseService {


    @Autowired
    private SysStationMappper sysStationMappper;

    @Autowired
    private DimLocationBaseInfoMapper locationMapper;


    @Override
    public Map<String, Object> importData(List stations) {
        return null;
    }

    @Override
    public Map<String, Object> getOwnCityAndStation(Long userId) {
        List<Map<String, Object>> maps = sysStationMappper.selectAll(userId);
        Map<String, Object> result = new HashMap<>();
        ArrayList<String> arrayList = new ArrayList<>();
        maps.forEach(a -> {
            if (!arrayList.contains((String) a.get("city"))) {
                arrayList.add((String) a.get("city"));
            }
        });
        result.put("city", arrayList);
        result.put("station", maps);
        return result;
    }

    @Override
    public Map<String, Object> getHmCityAndStation(Long userId) {
        List<Map<String, Object>> maps = sysStationMappper.selectStationAndShop(userId);
        Map<String, Object> result = new HashMap<>();
        ArrayList<String> arrayList = new ArrayList<>();
        maps.forEach(a -> {
            if (!arrayList.contains((String) a.get("city"))) {
                arrayList.add((String) a.get("city"));
            }
        });
        result.put("city", arrayList);
        result.put("station&Shop", maps);
        return result;
    }

    @Override
    public JSONObject getLocationAllInOne(String allowCity) {
        JSONObject jsonObject = new JSONObject();
        List<DimLocationBaseInfo> list = locationMapper.selectAllInOne(allowCity);
        Set<String> y = list.stream().filter(a -> a.getCityAvailableFlag().equals("Y"))
                .collect(Collectors.groupingBy(DimLocationBaseInfo::getCityName)).keySet();
        jsonObject.put("city", y);
        Stream<JSONObject> y1 = list.stream().filter(a -> a.getPostAvailableFlag().equals("Y"))
                .map(a -> {
                    DimLocationBaseInfo info = new DimLocationBaseInfo();
                    info.setCityName(a.getCityName());
                    info.setPostStationName(a.getPostStationName());
                    return info;
                }).distinct()
                .collect(Collectors.toList()).stream().map(a -> {
                    JSONObject j1 = new JSONObject();
                    j1.put("city", a.getCityName());
                    j1.put("postStation", a.getPostStationName());
                    return j1;
                });
        jsonObject.put("postStation", y1);

        Stream<JSONObject> stream = list.stream().filter(a -> a.getStationAvailableFlag().equals("Y")).map(a -> {
            DimLocationBaseInfo info = new DimLocationBaseInfo();
            info.setCityName(a.getCityName());
            info.setPostStationName(a.getPostStationName());
            info.setStationName(a.getStationName());
            return info;
        }).distinct().collect(Collectors.toList()).stream().map(a -> {
            JSONObject j1 = new JSONObject();
            j1.put("city", a.getCityName());
            j1.put("postStation", a.getPostStationName());
            j1.put("station", a.getStationName());
            return j1;
        });
        jsonObject.put("station", stream);

        Stream<JSONObject> stream2 = list.stream().filter(a -> a.getHmStationAvailableFlag().equals("Y")).map(a -> {
            DimLocationBaseInfo info = new DimLocationBaseInfo();
            info.setCityName(a.getCityName());
            info.setPostStationName(a.getPostStationName());
            info.setStationName(a.getStationName());
            info.setHmStationName(a.getHmStationName());
            return info;
        }).distinct().collect(Collectors.toList()).stream().map(a -> {
            JSONObject j1 = new JSONObject();
            j1.put("city", a.getCityName());
            j1.put("postStation", a.getPostStationName());
            j1.put("station", a.getStationName());
            j1.put("hmStation", a.getHmStationName());
            return j1;
        });
        jsonObject.put("hmStation", stream2);

        Stream<JSONObject> stream1 = list.stream().filter(a -> a.getHmShopAvailableFlag().equals("Y")).map(a -> {
            DimLocationBaseInfo info = new DimLocationBaseInfo();
            info.setCityName(a.getCityName());
            info.setHmShopName(a.getHmShopName());
            return info;
        }).distinct().collect(Collectors.toList()).stream().map(a -> {
            JSONObject j1 = new JSONObject();
            j1.put("city", a.getCityName());
            j1.put("hmShop", a.getHmShopName());
            return j1;
        });
        jsonObject.put("hmShop", stream1);

        return jsonObject;
    }
}
