package com.jzlife.report.service.newreport.impl;

import com.github.pagehelper.PageHelper;
import com.google.common.collect.Lists;
import com.jzlife.report.dao.reports.MarketReportMapper;
import com.jzlife.report.dao.reports.SPMapper;
import com.jzlife.report.dto.*;
import com.jzlife.report.service.newreport.MarketReportService;
import com.jzlife.report.vo.DayReportBaseVo;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

@Service
public class MarketReportServiceImpl implements MarketReportService {


    @Resource
    MarketReportMapper marketReportMapper;

    /**
     * 新客复购率报表
     */
    public List<ReportNewCustomerRebuy> getNewCustomerRebuyList(String month, String cType, String rebuy) {
        return marketReportMapper.selectNewCustomerRebuy(month, cType, rebuy);
    }

    /**
     * 销售提醒报表
     *
     * @param pageNo
     * @param pageSize
     * @param city
     * @param bookDate
     * @return
     */
    public List<ReportMarketRebuyRemind> getMarketRebuyRemindByCity(Integer pageNo, Integer pageSize, String city, String bookDate) {
        return marketReportMapper.sp_get_market_rebuy_remind_by_city(pageNo, pageSize, city, bookDate);
    }

    /**
     * 月订单及新客量
     *
     * @param month
     * @param pageNo
     * @param pageSize
     * @return
     */
    @Override
    public List<ReportSalesNewcustomerV3> getNewCustomer(String month, Integer pageNo, Integer pageSize) {
        PageHelper.startPage(pageNo, pageSize);
        return marketReportMapper.selectNewCusteomrByMonth(month);
    }

    /**
     * 周期老客续存率
     *
     * @param month
     * @return
     */
    @Override
    public List<ReportOldCustomerRebuy> getOldCustomerRebuy(String month) {
        List<ReportOldCustomerRebuy> list = marketReportMapper.selectOldCustomerRebuy(month);
        if (list == null)
            list = Lists.newArrayList();
        return list;
    }

    @Override
    public List<ReportNewCustomerRebuyBJTotal> serviceNewCustomerRebuyBJTotal(String month) {
        return marketReportMapper.reportNewCustomerRebuyBJTotal(month);
    }

    @Override
    public Object getMarketActivity202211(Integer type) {
        if (type != 0)
            return marketReportMapper.reportMarketActivity202211(type);
        else
            return marketReportMapper.reportMarketActivityDetail202211(type);
    }

}
