package com.jzlife.report.service.nurse;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.jzlife.report.dao.manager.SysStationMappper;
import com.jzlife.report.dao.nurse.SysCityMapper;
import com.jzlife.report.dao.nurse.SysRoleDataMapper;
import com.jzlife.report.dao.nurse.SysUserauthMapper;
import com.jzlife.report.entity.nurse.SysRoleData;
import com.jzlife.report.entity.nurse.SysUserauth;

@Service
public class CityStationService {

	@Autowired
	SysRoleDataMapper roleDataMapper;

	@Autowired
	SysUserauthMapper authMapper;

	@Autowired
	SysStationMappper sysStationMappper;

	@Autowired
	SysCityMapper cityMapper;

	public Map<String, Object> getReportUserDataAuth(Long userId) {
		List<SysUserauth> listUserAuth = authMapper.selectByUserId(userId);// 用户角色权限
		Map<String, Object> map = new HashMap<String, Object>();

		if (null == listUserAuth || listUserAuth.size() == 0) {
			return map;
		}

		List<SysRoleData> tempcityDataList = new ArrayList<SysRoleData>();// 城市
		List<SysRoleData> tempstationDataList = new ArrayList<SysRoleData>();// 服务站
//		List<Map<String, Object>> maps = sysStationMappper.selectAll();

		// 每个角色的 城市和服务站权限
		for (SysUserauth e : listUserAuth) {
			List<SysRoleData> cityDataList = roleDataMapper.getDataByType(e.getRoleId(), 1);// 城市
			if (null != cityDataList && cityDataList.size() > 0) {
				tempcityDataList.addAll(cityDataList);
			}

			List<SysRoleData> stationDataList = roleDataMapper.getDataByType(e.getRoleId(), 2);// 服务站
			if (null != stationDataList && stationDataList.size() > 0) {
				tempstationDataList.addAll(stationDataList);
			}

		}

		// 去从
		tempcityDataList = tempcityDataList.stream().distinct().collect(Collectors.toList());
		tempstationDataList = tempstationDataList.stream().distinct().collect(Collectors.toList());

		List<SysRoleData> tempyx = new ArrayList<SysRoleData>();// 临时所有的

		for (SysRoleData e : tempcityDataList) {
			List<SysRoleData> tempStation = new ArrayList<SysRoleData>();
			for (SysRoleData c : tempstationDataList) {
				if (c.getDataName().contains(e.getDataName())) {
					tempStation.add(c);
					tempyx.add(c);
				}
			}
			e.setSubList(tempStation);
		}

		List<SysRoleData> tempall = new ArrayList<SysRoleData>();// 得到没有关联的
		tempall.addAll(tempstationDataList);
		tempall.removeAll(tempyx);

		for (SysRoleData s : tempall) {
			Map<String, String> maps = sysStationMappper.selectStationByName(s.getDataName());
			if (maps != null && maps.size() > 0) {
				String city = maps.get("city");
//				String station= maps.get("station");
				for (SysRoleData e : tempcityDataList) {
					if (e.getDataName().equals(city)) {
						if (e.getSubList() != null) {
							e.getSubList().add(s);
						} else {
							List<SysRoleData> tempStation = new ArrayList<SysRoleData>();
							tempStation.add(s);
							e.setSubList(tempStation);
						}
						break;
					}
				}
			}
		}

		map.put("userCityDataList", tempcityDataList);
		map.put("userStationDataList", tempstationDataList);
		return map;
	}
	
	public List<String> getUserCity(Integer userId){
		return roleDataMapper.getUserReportCity(userId);
	}
	
	public String getUserCityString(Integer userId){
		List<String> userReportCity = roleDataMapper.getUserReportCity(userId);
		if(userReportCity!=null&&userReportCity.size()>0) {
			return String.join(",", userReportCity);
		}
		return null;
	}

	public static void main(String[] args) {
		System.out.println("吃饭啊".contains("吃"));
	}
}
