package com.jzlife.report.service.nurse.impl;

import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.jzlife.report.dao.reports.TTempClueMapper;
import com.jzlife.report.entity.reports.TTempClue;
import com.jzlife.report.service.nurse.SanSaoService;
import com.jzlife.report.vo.SanSaoVo;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
@Slf4j
public class SanSaoServiceImpl implements SanSaoService {


    @Autowired
    private TTempClueMapper tTempClueMapper;

    @Override
    public Object selectSanSaoContractList(SanSaoVo sanSaoVo) {
        PageHelper.startPage(sanSaoVo.getPageNo(), sanSaoVo.getPageSize());
        transfer(sanSaoVo);
        List<TTempClue> list = tTempClueMapper.selectSanSaoContractList(sanSaoVo);
        return new PageInfo<>(list);
    }

    private void transfer(SanSaoVo sanSaoVo) {
        if (StringUtils.isNotEmpty(sanSaoVo.getServiceModel())) {
            switch (sanSaoVo.getServiceModel()) {
                case "10":
                    sanSaoVo.setServiceModel("钟点工");
                    break;
                case "11":
                    sanSaoVo.setServiceModel("家务保姆");
                    break;
                case "12":
                    sanSaoVo.setServiceModel("育儿嫂");
                    break;
                case "20":
                    sanSaoVo.setServiceModel("月嫂");
                    break;
                case "30":
                    sanSaoVo.setServiceModel("代班钟点工");
                    break;
                case "31":
                    sanSaoVo.setServiceModel("代班保姆");
                    break;
            }
        }
        if (StringUtils.isNotBlank(sanSaoVo.getState())) {
            switch (sanSaoVo.getState()) {
                case "1":
                    sanSaoVo.setState("待签署");
                    break;
                case "2":
                    sanSaoVo.setState("已签署(待审核)");
                    break;
                case "3":
                    sanSaoVo.setState("已取消");
                    break;
                case "4":
                    sanSaoVo.setState("签署完成");
                    break;
            }
        }


    }

    @Override
    public List<TTempClue> selectSanSaoContractListNoPage(SanSaoVo sanSaoVo) {
        transfer(sanSaoVo);
        return tTempClueMapper.selectSanSaoContractList(sanSaoVo);
    }
}
