package com.jzlife.report.service.report.impl;

import com.jzlife.report.dao.douyin.OrderReservationVerificationMapper;
import com.jzlife.report.dto.*;
import com.jzlife.report.dto.douyin.BookVerifyDetailVo;
import com.jzlife.report.dto.douyin.DouyinBookTotalByFraVo;
import com.jzlife.report.dto.douyin.DouyinVerifyDetailByTanletVo;
import com.jzlife.report.dto.douyin.DouyinVerifyDetailFraVo;
import com.jzlife.report.service.report.OrderReservationVerificationService;

import com.jzlife.report.util.DateUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class OrderReservationVerificationServiceImpl implements OrderReservationVerificationService {
    @Autowired
    OrderReservationVerificationMapper orderReservationVerificationMapper;

    @Override
    public List<OrderReservationRateDto> getOrderReservationRate(OrderReservationQueryDto queryDto) {
        return orderReservationVerificationMapper.getOrderReservationRate(queryDto);
    }

    @Override
    public List<RefundAfterReservationDto> getRefundAfterReservation(OrderReservationQueryDto queryDto) {
        return orderReservationVerificationMapper.getRefundAfterReservation(queryDto);
    }

    @Override
    public List<VerificationRateWeekDto> getVerificationRateWeek(OrderReservationQueryDto queryDto) {
        List<VerificationRateWeekDto> verificationRateWeek = orderReservationVerificationMapper.getVerificationRateWeek(queryDto);
        for (VerificationRateWeekDto verificationRateWeekDto : verificationRateWeek) {
            String[] split = verificationRateWeekDto.getCreateTime().split("-");
            String startDayOfWeekNo = DateUtil.getStartDayOfWeekNo(Integer.parseInt(split[0]), Integer.parseInt(split[1]));
            String endDayOfWeekNo = DateUtil.getEndDayOfWeekNo(Integer.parseInt(split[0]), Integer.parseInt(split[1]));
            verificationRateWeekDto.setDateRange(startDayOfWeekNo + " ~ " + endDayOfWeekNo);
        }
        return verificationRateWeek;
    }

    @Override
    public List<VerificationRateMonthDto> getVerificationRateMonth(OrderReservationQueryDto queryDto) {
        return orderReservationVerificationMapper.getVerificationRateMonth(queryDto);
    }

    @Override
    public List<ContactOrderDto> getContactOrder(OrderReservationQueryDto queryDto) {
        return orderReservationVerificationMapper.getContactOrder(queryDto);
    }

    //预约后退款 预约维度
    @Override
    public List<RefundAfterBookDateDto> getRefundAfterByBookDate(OrderReservationQueryDto queryDto) {
        return orderReservationVerificationMapper.getRefundAfterByBookDate(queryDto);
    }

    @Override
    public List<DouyinVerifyDetailFraVo> getVerifyDetailByBookDate(OrderReservationQueryDto queryDto) {
        return orderReservationVerificationMapper.getVerifyDetailByBookDate(queryDto);
    }


    //核销明细表（达人维度）
    @Override
    public  List<DouyinVerifyDetailByTanletVo> getVerifyDetailByTanlet(OrderReservationQueryDto queryDto){
        return orderReservationVerificationMapper.getVerifyDetailByTanlet(queryDto);
    }


    //核销预约明细表
    @Override
    public  List<BookVerifyDetailVo> getVerifyDetailList(OrderReservationQueryDto queryDto){
        return orderReservationVerificationMapper.getVerifyDetailList(queryDto);
    }


    //预约汇总by加盟商
    @Override
    public  List<DouyinBookTotalByFraVo> getBookTotalByFra(OrderReservationQueryDto queryDto){
        return orderReservationVerificationMapper.getBookTotalByFra(queryDto);
    }
}
