package com.jzlife.report.util;

import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;

public class DateUtils {
	public static SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd");

	public static SimpleDateFormat format2 = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");

	public static SimpleDateFormat format3 = new SimpleDateFormat("yyyy-MM");

	public static String getCurrentDay() {
		return format.format(new Date());
	}
	
	/**
	 * 获取前一天
	 * 
	 * @param date 当前日期
	 * @return
	 */
	public static String getFrontDay(Date date) {
		Calendar c = Calendar.getInstance();
		c.setTime(date);
		c.add(Calendar.DATE, -1);

		return format.format(c.getTime());
	}

	/**
	 * 获取前一天的月份，的第一天
	 */
	public static String qytdyddyt(Date date) {
		String frontDay = getFrontDay(date);
		String substring = frontDay.substring(5, 7);
		String y = frontDay.substring(0, 4);

		Calendar c = Calendar.getInstance();

		c.set(Calendar.YEAR, Integer.parseInt(y));
		c.set(Calendar.MONTH, Integer.parseInt(substring) - 1);

		c.set(Calendar.DAY_OF_MONTH, 1);// 设置为1号,当前日期既为本月第一天
		String first = format.format(c.getTime());
		return first;
	}

	/**
	 * 前一天的上月当日
	 * 
	 * @return
	 */
	public static String getqytsydr(Date date) {
		Calendar c = Calendar.getInstance();
		c.setTime(date);
		c.add(Calendar.DATE, -1);
		c.add(Calendar.MONTH, -1);
		return format.format(c.getTime());
	}
	
	/**
	 * 前多少天的上月当日
	 * 
	 * @return
	 */
	public static String getqytsydr(Date date,Integer d) {
		Calendar c = Calendar.getInstance();
		c.setTime(date);
		c.add(Calendar.DATE, -d);
		c.add(Calendar.MONTH, -1);
		return format.format(c.getTime());
	}

	/**
	 * 前一天的上月第一天
	 * 
	 * @return
	 */
	public static String getqytsydyt(Date date) {
		Calendar c = Calendar.getInstance();
		c.setTime(date);
		c.add(Calendar.DATE, -1);
		c.add(Calendar.MONTH, -1);
		c.set(Calendar.DAY_OF_MONTH, 1);
		return format.format(c.getTime());
	}
	// --------------------------------------环比上月---------------------------------

//	/**
//	 * 获取前一天所在年的第一天
//	 * @return
//	 */
//	public static String getqytnian() {
//		Calendar c = Calendar.getInstance(); 
//		c.add(Calendar.DATE, -1);
//		c.set(Calendar.DAY_OF_MONTH, 1);
//		c.set(Calendar.DAY_OF_YEAR, 1);
//		return format.format(c.getTime());
//	}

	/**
	 * 获取前一天对应的去年的日期 所在月的第一天
	 * 
	 * @return
	 */
	public static String getqytqndrq(Date date) {
		Calendar c = Calendar.getInstance();
		c.setTime(date);
		c.add(Calendar.DATE, -1);
		c.add(Calendar.YEAR, -1);
		c.set(Calendar.DAY_OF_MONTH, 1);
		return format.format(c.getTime());
	}

	/**
	 * 获取前一天对应的去年日期
	 * 
	 * @return
	 */
	public static String getqytqn(Date date) {
		Calendar c = Calendar.getInstance();
		c.setTime(date);
		c.add(Calendar.DATE, -1);
		c.add(Calendar.YEAR, -1);
		return format.format(c.getTime());
	}

	public static synchronized Date isThisTime(String ym) {
		String now = format3.format(new Date());// 当前时间
		if (ym.equals(now)) {
			// 属于当月返回当日
			return new Date();
		}
		// 不是当月返回月的最后一天
		Calendar c = Calendar.getInstance();
		try {
			c.setTime(format3.parse(ym));
		} catch (ParseException e) {
			e.printStackTrace();
		}
//        c.add(Calendar.MONTH, -1);
		c.set(Calendar.DAY_OF_MONTH, c.getActualMaximum(Calendar.DAY_OF_MONTH));
		return c.getTime();
	}

	// ---------------------------------同比去年----------------------------------------------
	/**
	 * 获取当前月第一天
	 * 
	 * @return
	 */
	public static String getMonthFirstDay() {
		Calendar c = Calendar.getInstance();
		c.add(Calendar.MONTH, 0);
		c.set(Calendar.DAY_OF_MONTH, 1);// 设置为1号,当前日期既为本月第一天
		String first = format.format(c.getTime());
		return first;
	}

	/**
	 * 获取当月的最后一天
	 * 
	 * @return
	 */
	public static String getMonthEndDay() {
		Calendar ca = Calendar.getInstance();
		ca.set(Calendar.DAY_OF_MONTH, ca.getActualMaximum(Calendar.DAY_OF_MONTH));
		String last = format.format(ca.getTime());
		return last;
	}

	/**
	 * 获取某年某月的最后一天
	 * 
	 * @param year
	 * @param month
	 * @return
	 */
	public static String getLastDayOfMonth(int year, int month) {
		Calendar calendar = Calendar.getInstance();
		calendar.set(Calendar.YEAR, year);
		calendar.set(Calendar.MONTH, month - 1);
		calendar.set(Calendar.DAY_OF_MONTH, 1);
		calendar.set(Calendar.DATE, calendar.getActualMaximum(Calendar.DATE));
		DateFormat format = new SimpleDateFormat("yyyy-MM-dd ");
		return format.format(calendar.getTime());
	}

	/**
	 * 获取前一天的月份的最后一天
	 * 
	 * @return
	 */
	public static String qytdydzhyt() {
		String frontDay = getFrontDay(new Date());
		String substring = frontDay.substring(5, 7);
		String y = frontDay.substring(0, 4);

		Calendar c = Calendar.getInstance();

		c.set(Calendar.YEAR, Integer.parseInt(y));
		c.set(Calendar.MONTH, Integer.parseInt(substring) - 1);

		c.set(Calendar.DAY_OF_MONTH, c.getActualMaximum(Calendar.DAY_OF_MONTH));
		String last = format.format(c.getTime());
		return last;
	}
	
	// 判断是否当月
	public static Boolean checkThisTime(String ym) {
		String now = format3.format(new Date());// 当前时间
		if (ym.equals(now)) {
			return true;
		}
		 return false;
	}

	public static void main(String[] args) {
		String yearMonth = "2022-02";
		System.out.println(format.format(DateUtils.isThisTime(yearMonth)));

		System.out.println("----------环比上月------------");
		System.out.println(
				qytdyddyt(DateUtils.isThisTime(yearMonth)) + "  " + getFrontDay(DateUtils.isThisTime(yearMonth)));
		System.out.println(
				getqytsydyt(DateUtils.isThisTime(yearMonth)) + "  " + getqytsydr(DateUtils.isThisTime(yearMonth)));

		System.out.println("----------同比去年------------");
		System.out.println(
				qytdyddyt(DateUtils.isThisTime(yearMonth)) + "  " + getFrontDay(DateUtils.isThisTime(yearMonth)));
		System.out.println(
				getqytqndrq(DateUtils.isThisTime(yearMonth)) + "   " + getqytqn(DateUtils.isThisTime(yearMonth)));
	}

}
