package com.jzlife.report.util;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Random;
import java.util.Map.Entry;

public class MapUtil {

	/**
	 * 降序排列,根据key
	 * 
	 * @param k_v
	 * @return
	 */
	public static Map sortMap(Map k_v) {
		List<Map.Entry<Integer, Object>> list = new ArrayList<Map.Entry<Integer, Object>>(k_v.entrySet());
		Collections.sort(list, new Comparator<Map.Entry<Integer, Object>>() {

			public int compare(Map.Entry<Integer, Object> o1, Map.Entry<Integer, Object> o2) {
				// 降序排列
				return o2.getKey() - o1.getKey();
			}
		});
		Map result = new LinkedHashMap();
		for (Entry<Integer, Object> entry : list) {
			result.put(entry.getKey(), entry.getValue());

		}

		return result;
	}

	/**
	 *      * 按key排序(sort by value).      *       * @param oriMap 要排序的map集合     
	 * * @param isAsc（true:升序，false：降序）      * @return     
	 */
	public static Map<Double, List<Long>> sortMapByKey(Map<Double, List<Long>> oriMap, final boolean isAsc) {
		Map<Double, List<Long>> sortedMap = new LinkedHashMap<Double, List<Long>>();
		if (oriMap != null && !oriMap.isEmpty()) {
			List<Map.Entry<Double, List<Long>>> entryList = new ArrayList<Map.Entry<Double, List<Long>>>(
					oriMap.entrySet());
			Collections.sort(entryList, new Comparator<Map.Entry<Double, List<Long>>>() {
				public int compare(Entry<Double, List<Long>> entry1, Entry<Double, List<Long>> entry2) {

					Double key1 = entry1.getKey();
					Double key2 = entry2.getKey();

					// 判定
					int rst = 0;
					if (isAsc) {
						rst = key1.compareTo(key2);
					} else {
						rst = key2.compareTo(key1);
					}
					return rst;
				}
			});
			Iterator<Map.Entry<Double, List<Long>>> iter = entryList.iterator();
			Map.Entry<Double, List<Long>> tmpEntry = null;
			while (iter.hasNext()) {
				tmpEntry = iter.next();
				sortedMap.put(tmpEntry.getKey(), tmpEntry.getValue());
			}
		}
		return sortedMap;
	}


	/**
	 * 随机从list中获取值
	 * 
	 * @param listId
	 * @param servicenum
	 * @return
	 */
	public static List<Long> lastRandomVal(List<Long> listId, Integer servicenum) {
		Random random = new Random();
		List<Long> randomlist = new ArrayList<Long>();
		if (listId.size() > servicenum) {
			boolean boo = true;
			while (boo) {
				Long id = listId.get(random.nextInt(listId.size()));
				if (!randomlist.contains(id)) {
					randomlist.add(id);
				}
				if (randomlist.size() == servicenum) {
					boo = false;
				}
			}
		} else {
			randomlist = listId;// 没有多余的值
		}
		return randomlist;
	}

}
