package com.jzlife.report.vo;


import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Pattern;

@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class InvestmentAndResignVo {

    @ApiModelProperty(value = "城市名称" ,notes = "支持多个城市名称，多个城市名称用【,】分开")
    private String city;


    @ApiModelProperty(value = "开始时间", notes = "时间格式为 yyyy-MM-dd")
    @NotNull(message = "开始时间不可为空")
    @Pattern(regexp = "^20(19|2\\d)-(0[1-9]|1[012])-[0123][0-9]$", message = "开始时间不合法")
    private String startTime;

    @ApiModelProperty(value = "结束时间", notes = "时间格式为 yyyy-MM-dd")
    @NotNull(message = "结束时间不可为空")
    @Pattern(regexp = "^20(19|2\\d)-(0[1-9]|1[012])-[0123][0-9]$", message = "结束时间不合法")
    private String endTime;


    @ApiModelProperty(value = "驿站名称", notes = "驿站名称")
    private String postStation;

    @ApiModelProperty(value = "服务站名称", notes = "服务站名称")
    private String serviceStation;

    @ApiModelProperty(value = "来源", notes = "复职，自然流量，渠道，合伙人,自招,转介绍")
    private String resource;


}
