package com.jzlife.report.vo;


import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.validation.constraints.NotNull;
import javax.validation.constraints.Pattern;

@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class ReportStationAndShopVo {

    @ApiModelProperty(value = "城市名称")
    private String city;


    @ApiModelProperty(value = "开始时间", notes = "时间格式为 yyyy-MM-dd")
    @NotNull(message = "开始时间不可为空")
    @Pattern(regexp = "^20(19|2\\d)-(0[1-9]|1[012])-(0[1-9]|1[0-9]|2[0-9]|3[01])$", message = "开始时间不合法")
    private String startTime;


    @ApiModelProperty(value = "服务站名称", notes = "盒马服务站名称  可多选，【,】分割")
    private String serviceStation;

    @ApiModelProperty(value = "门店名称", notes = "门店名称")
    private String shopName;


//    @ApiModelProperty(value = "商品类型", notes = "1 保洁 2品类")
//    @Pattern(regexp = "\\s+|1|2|^$")
//    private String productType;

    @ApiModelProperty(value = "服务站类型", notes = "1 保洁 2品类")
    @Pattern(regexp = "\\s+|1|2|^$")
    private String stationType;
}
